' ********** Copyright 2015 Roku Corp.  All Rights Reserved. **********

' Component initialization, setting default properties
sub init()
    print ">>> RokuAuthScreen :: init()"
    m.top.visible = false

    m.global.observeField("appColor","onAppColorChange")



    m.top.posterSplash = m.top.CreateChild("Poster")
    m.rectangle = m.top.CreateChild("Rectangle")
    m.rectangle.width = 1280
    m.rectangle.height = 720
    m.rectangle.color = m.global.appColor

    m.group = m.top.createChild("LayoutGroup")
    m.group.translation = [650, 50]
    m.group.itemSpacings = [40, 0]
    m.group.horizAlignment = "center"
    m.group.vertAlignment = "top"
    m.group.layoutDirection = "vert"

    m.logoGroup = m.group.createChild("LayoutGroup")
    m.logoGroup.layoutDirection = "horiz"
    m.logoGroup.vertAlignment = "bottom"
    m.logoGroup.translation = [550, 50]

    m.logo = m.logoGroup.createChild("Poster")
    m.logo.uri = "pkg:/images/logo.png"

    'get Channel version
    appInfo = CreateObject("roAppInfo")
    m.version = m.logoGroup.CreateChild("Label")
    m.version.Font.size = 16
    m.version.horizAlign = "center"
    m.version.vertAlign = "center"
    m.version.text = "V" + appInfo.GetVersion()

    m.accountTextGroup = m.group.createChild("LayoutGroup")
    m.accountTextGroup.layoutDirection = "horiz"
    m.accountTextGroup.translation = [480,150]
    m.accountTextGroup.itemSpacings = [10]

    m.accountCaption = m.accountTextGroup.CreateChild("Label")
    m.accountCaption.horizAlign = "center"
    m.accountCaption.vertAlign = "center"
    m.accountCaption.text = "Device email:"

    m.email = m.accountTextGroup.CreateChild("Label")
    m.email.horizAlign = "center"
    m.email.vertAlign = "center"

    m.global.observeField("device_email", "onDeviceEmailChange")

    m.label = m.group.CreateChild("Label")
    m.label.horizAlign = "center"
    m.label.vertAlign = "center"
    m.label.width = 500
    m.label.height= 300
    m.label.wrap = true
    m.label.translation = "[400,200]"

    m.top.buttonLogin = m.top.CreateChild("Button")
    m.top.buttonLogin.text = "Already a member (log in)"
    m.top.buttonLogin.minWidth = 400
    m.top.buttonLogin.translation = [100,550]
    m.top.buttonLogin.showFocusFootprint = true

    m.top.buttonSubscribe = m.top.createChild("Button")
    m.top.buttonSubscribe.text = "Activate"
    m.top.buttonSubscribe.minWidth = 200
    m.top.buttonSubscribe.maxWidth = 210
    m.top.buttonSubscribe.translation = [550,550]
    m.top.buttonSubscribe.showFocusFootprint = true

    m.top.buttonLogout = m.top.createChild("Button")
    m.top.buttonLogout.text = "Sign out"
    m.top.buttonLogout.minWidth = 200
    m.top.buttonLogout.maxWidth = 210
    m.top.buttonLogout.translation = [550,550]
    m.top.buttonLogout.showFocusFootprint = true

    m.top.buttonSignup = m.top.CreateChild("Button")
    m.top.buttonSignup.text = "New member (sign up)"
    m.top.buttonSignup.minWidth = 400
    m.top.buttonSignup.translation = [800,550]
    m.top.buttonSignup.showFocusFootprint = true
end sub

sub OnSetUI()
    if m.top.setUI
       m.top.buttonSubscribe.translation = [400,550]
       m.top.buttonLogout.translation = [700,550]
    else
       m.top.buttonLogout.translation = [550,550]
    end if
end sub

sub onDeviceEmailChange(event as Object)
    m.email.text = event.getData()
end sub

sub onAppColorChange(event as Object)
    m.rectangle.color = event.getData()
end sub

sub OnTextChange(event as Object)
    text = event.getData()
    m.label.text = text
end sub

' Overridden Key event handler for button focus processing
function onKeyEvent(key as String, bPressed as Boolean) as Boolean
    result = false

    if m.global.isSubscribe
        return result
    end if
    if bPressed and (key = "left" OR key = "right")
       if m.top.buttonSubscribe.visible
          if m.top.buttonSubscribe.hasFocus()
             m.top.buttonLogout.setFocus(true)
          else if m.top.buttonLogout.hasFocus()
             m.top.buttonSubscribe.setFocus(true)
          end if
       else if NOT m.top.buttonLogout.visible
            bButtonLoginFocused = m.top.buttonLogin.hasFocus()
            m.top.buttonLogin.setFocus(not bButtonLoginFocused)
            m.top.buttonSignup.setFocus(bButtonLoginFocused)
       end if
       result = true
    end if
    return result
end function


' onChange handler for "show" field
sub On_show(event as Object)
    show = event.getData()
    m.top.visible = show
end sub
