sub init()
    m.menuBackground = m.top.findNode("menuBackground")
    m.menuBackground.width = 1280
    m.menuBackground.height = 90
    m.menuBackground.translation = [0,0]
    m.menuBackground.blendColor = "0x000000"
    
    m.menuList = m.top.FindNode("menuList")
    m.menuList.rowHeights = [80]
    m.menuList.numRows = 1
end sub

sub onMenuItemsChange(event as Object)
    loadMenuContent(event.getData())
end sub

sub onItemSelected(event as Object)
    if NOT m.top.visible OR m.top.translation[1] < 0
        return
    end if

    m.top.pageNameSelected = m.top.items[event.getData()]
end sub

sub onFocusChange(event as Object)
    m.menuList.SetFocus(event.getData())
end sub

sub loadMenuContent(menuTitles as Object)
    m.content = createObject("RoSGNode","ContentNode")    
    columnWidths = []
    width = 0
    columnsCount = 0
    spacingWidth = 30
    
    templateLable = createObject("RoSGNode","Label") 
    templateLable.font.size = 27
    templateLable.height = 44
        
    for each title in menuTitles
        dataItem = m.content.CreateChild("ContentNode")
        dataItem.title = title
        templateLable.text = title
        
        columnWidth = templateLable.boundingRect().width + 30
        
        width = width + columnWidth + spacingWidth
        
        if width < 1280
            columnsCount += 1
        end if
        columnWidths.push(columnWidth)
    end for
   
    widthItem = width / menuTitles.count()
    templateLable = invalid
    
    m.menuList.numColumns = columnsCount
    m.menuList.columnWidths = columnWidths
    m.menuList.itemSize = [widthItem * columnsCount, 50]
    m.menuList.itemSpacing = [spacingWidth, 0]
    
    m.menuList.content = m.content
    m.menuList.SetFocus(true)    
    deviceInfo = CreateObject("roDeviceInfo")
    
    menuPosX = (1280 - m.menuList.boundingRect().width)/2
    
    m.menuList.translation = [menuPosX, 30] 
    
    m.menuList.ObserveField("itemSelected","onItemSelected")    
end sub

Function OnkeyEvent(key, press) as Boolean
    if (press)
     ?"[Menu] onKeyEvent = ";key
     if key = "down"
        m.top.focus = false
        return true
     end if
    end if
    
    return false 
end function